<?php
// Dernière mise à jour: 14/07/2024
/* But de ce programme:
 1) Rechercher des doublons objet selon le type de donnée et un critère de recherche
 a) l'appui sur le bouton Rechercher
  Affiche un tableau des objets doublons trouvés avec un marqueur pour l'utilisateur
  Ce marqueur détermine :
  1) l'objet retenu comme référence
  2) les objets à supprimer par l'objet référence
  3) les objets inchangés (non modifiés) 
 b) l'appui sur le bouton Eliminer doublons objet
  Remplace les IdComposant des objets à supprimer de la table relation par le IdComposant de référence
  Puis supprime les objets marqués à supprimer.
  
 2) Rechercher les doublons fiches selon le type de fiche
 a) sélection type de fiche
 b) appui sur le bouton Eliminer doublons fiche
  recherche les doublons (même nombre et même valeurs IdComposant pour des fiches différentes)
  pour chaque fiche doublon trouvée, remplacer IdComposant de relation par IdComosant de fiche référence (1ère),
  supprimer la fiche doublons et ses relations inutiles  
*/

if (!isset($_SESSION)) session_start(); 		// démarre la session
//error_reporting(E_ALL & ~E_NOTICE & ~E_WARNING);	// invalide erreur NOTICE et WARNING
include('lib/lib.php'); 				// inclue fonctions génériques (ici: ouvreBase et afficheChamp)
$bdd = ouvreBase(); 					// ouvre la base de données ;
include('lib/ban-menu.php'); 				// affiche entête Html, bannière personnalisée et menu dynamique
// contrôle accès autorisé à admin et gestionnaire
autorise(array(5,9));
initBase($bdd);				// récup $IdRacGen, $IdRacObj $IdRacFic et $IdRacRel

DEFINE ('gestiondoublonsIdref','Id référence');
DEFINE ('gestiondoublonsIdmod','Id à modifier');
DEFINE ('gestiondoublonsIdgarde','Id gardé non modifié');
DEFINE ('gestiondoublonsErr','Erreur ! ');
DEFINE ('gestiondoublonsErr1',' éléments marqués comme retenu ! Un seul possible.');
DEFINE ('gestiondoublonsErr0',' élément marqué comme retenu ! Il en faut un et un seul.');
DEFINE ('gestiondoublonsOK','reprise et suppression de ');
DEFINE ('gestiondoublonsOK1',' objets doublons effectuée');
DEFINE ('gestiondoublonsOK2',' fiches doublons effectuée');
DEFINE ('gestiondoublonsKO','Erreur ! Rien n\'a été enregistré ou modifié !');
DEFINE ('gestiondoublons0','Attention ! Pas de doublons trouvés');
DEFINE ('gestiondoublonsTitre','<h4>Affichage des doublons trouvés pour traitement</h4>');
DEFINE ('gestiondoublonsGuide','<p>Marquer l\'objet retenu comme <b>Id référence</b>. Marquer le ou les autres objets comme <b>Id à modifier</b>.<br>Laisser le marqueur à <b>Id gardé non modifié</b> pour d\'autres objets non concernés.<br>Puis appuyer sur le bouton <b>Eliminer doublons</b>.</p>');
DEFINE ('gestiondoublonsLegende','<th>Id objet </th><th colspan="10">Désignation</th></tr>');
DEFINE ('gestiondoublonsAttention','Attention ! Aucune donnée trouvée !');
DEFINE ('gestiondoublonsTitre1','<h4>Gestion des doublons</h4>');
DEFINE ('gestiondoublonsGuide1','<p><b>Entrer une chaîne de caractères adhoc</b> pour sélectionner des doublons possibles et <b>choisir un type de donnée</b>.<br/>Utiliser le % comme joker pour sélectionner<br/>Exemple1: c% retrouve toute expression commençant par lettre c<br/>Exemple2: %Ab% retrouve toute expression contenant Ab<br/>Exemple3: %iaN retrouve toute expression finissant par iaN<br/>La recherche est sensible à la casse et aux accents<br>Puis appuyer sur le bouton <b>Rechercher</b></p>');
DEFINE ('gestiondoublonsDonnee','Critère de recherche ');
DEFINE ('gestiondoublonsType','Type de donnée ');
DEFINE ('gestiondoublonsIndef','Type indéfini');
DEFINE ('gestiondoublonsRecherObjet','Rechercher objets doublons');
DEFINE ('gestiondoublonsTypeF','Type de fiche ');
DEFINE ('gestiondoublonsRecherFiche','Eliminer fiches doublons');
DEFINE ('gestiondoublonsEliminer','Eliminer objets doublons');

// création des marqueurs
$choix = array();
$choix[0][0] = 1;
$choix[0][1] = gestiondoublonsIdref;
$choix[1][0] = 2;
$choix[1][1] = gestiondoublonsIdmod;
$choix[2][0] = 0;
$choix[2][1] = gestiondoublonsIdgarde;
$choix[0][2] = 0;

// traitement d'élimination des objets doublons
if (isset($_POST['traiter']) ) {
 $poubelle = array_pop($_POST); 			// éliminer le post du recher
 $poubelle = array_pop($_POST); 			// éliminer le post du message
/* Mémorise Id retenu (1)
  pour tous les éléments de Id à modifier (2)
   recherche les IdComosant = Id à modifier et remplace par Id retenu
 */
 $nbe = count($_POST);
 $nb1 = 0;
 for ($e=0;$e<$nbe;$e++) {
  if ($_POST['action'.$e] == 1) {
   $idretenu = $_POST['Id'.$e];
   $nb1++;
  }
 }
 if ($nb1 > 1) {
  $_POST['message'] = gestiondoublonsErr.$nb1.gestiondoublonsErr1;
 }
 elseif ($nb1 == 0) {
  $_POST['message'] = gestiondoublonsErr.$nb1.gestiondoublonsErr0; 
 }
 else {
  try {
   $bdd->beginTransaction(); 			// ouvre une transaction
   $nbu = 0;
   for ($e=0;$e<$nbe;$e++) {
    if ($_POST['action'.$e] == 2) { 		// si Id à modifier
     updateComposant($bdd,$_POST['Id'.$e],$idretenu);// remplace IdComposant par Id retenu
     $nbu++; 
     deleteObjet($bdd,$_POST['Id'.$e]);		// supprime objet de Id à modifier
    }
   }   
   $bdd->commit(); // valide la transaction et informe l'utilisateur
   $_POST['message'] = gestiondoublonsOK.$nbu.gestiondoublonsOK1;
  }
  catch(Exception $e) {
   $bdd->rollback();	// invalide la transaction
   $_POST['message'] = gestiondoublonsKO;
  } 
 }
}

// traitement d'élimination des fiches doublons
if (isset($_POST['traiterfiches'])) {
 $poubelle = array_pop($_POST); 			// éliminer le post du traiterfiches
 $poubelle = array_pop($_POST); 			// éliminer le post du message 
// print_r($_POST);
 try {
  $bdd->beginTransaction(); 			// ouvre une transaction
  $tablefiches = Array();
  $tabcomposants = Array();
  $idpere = $_POST['type'];
// rechercher les occurrences fiches filles de la fiche générique
  $occfiches = selectOccFils($bdd,$idpere);	// recherche les occ. fiche fille
  $nboccfiches = count($occfiches);
  for ($f=0;$f<$nboccfiches;$f++) {		// pour chaque occ. fiche fille
   $idfiche = $occfiches[$f][0];		// note son Id
   $composants = selectComposant($bdd,$idfiche);// recherche les composants de la fiche fille
   $nbcomposants = count($composants);  
   $liscles = "";
   for ($c=0;$c<$nbcomposants;$c++) {		// pour chaque composant de la fiche fille
    $idcomposant = $composants[$c][0];		// note son Id composant
    if ($liscles == "")
     $liscles = $idcomposant;
    else
     $liscles = $liscles.','.$idcomposant;	// ajoute cet Id en liste
   } 
   $chaine = explode(",",$liscles);
   asort($chaine);				// trie la liste des Id pour permettre comparaison
   $liscles = implode(",",$chaine);
   $tabfiches[$f] = $idfiche;			// note Id fiche fille
   $tabcomposants[$f] = $liscles;  		// note liste Id des composants triée
  }
  $tabdoublons = Array();			// table des doublons
  $doublons = 0;
  for ($c=0;$c<$nboccfiches;$c++) {		// pour chaque fille fille
   for ($d=$c+1;$d<$nboccfiches;$d++) {
    if ($tabcomposants[$c] != "") {		// ne traite pas les listes composants vides
     $doublons1 = $tabfiches[$c];
     $doublons2 = $tabfiches[$d];
     if ($tabcomposants[$d] == $tabcomposants[$c]) {// recherche et note les doublons
      $tabdoublons[$doublons1] = $tabcomposants[$c];
      $tabdoublons[$doublons2] = $tabcomposants[$c];
      $doublons++;
     }
    }
   }
  }
  if ($doublons == 0) {				// si pas de doublons trouvés
   $bdd->commit();
   $_POST['message'] = gestiondoublons0;  
  }
  else {					// si doublons trouvés
// ** algorithme testé avec un seul ensemble de doublons trouvé (ont tous même value) ** à retester
   $i = 0;
   $n = 0;
   foreach ($tabdoublons as $key => $value) {
    if ($i == 0) {				// Si 1er élément du tableau 
     $keyref = $key;				// note 1ère clé de référence
     $valref = $value;				// note 1ère valeur de l'ensemble
     $i++;
    } 
    else {					// pour tous les éléments suivants
     if ($valref == $value) {			// si même ensemble de doublons
      updateComposant($bdd,$key,$keyref);	// change les IdComposant (relations avec fiche référence)
      deleteObjet($bdd,$key);			// supprime la fiche doublon et ses relations
      $n++;					// décompte les doublons supprimés
     }
     else {					// si changement d'ensemble de doublons
      $valref = $value;				// note nouvelle valeur de l'ensemble
      $keyref = $key;				// note nouvelle clé de référence
     }
    }
   }
   $bdd->commit(); // valide la transaction et informe l'utilisateur
   $_POST['message'] = gestiondoublonsOK.$n.gestiondoublonsOK2;
  }
 }
 catch(Exception $e) {
  $bdd->rollback();	// invalide la transaction
  $_POST['message'] = gestiondoublonsKO;
 }  
}

// recherche des objets doublons
if (isset($_POST['recher']) ) {				
 $poubelle = array_pop($_POST); 			// élimine le post du recher
 $poubelle = array_pop($_POST); 			// élimine le post du message
 echo '<form method="POST" action="gestiondoublons.php">';
 echo gestiondoublonsTitre;
 echo gestiondoublonsGuide;
 $donnee = $_POST['donnee']; 
 if ($donnee == "") $donnee = "%";
 $idpere = $_POST['type'];
// rechercher toutes les occurrences du type d'objet sélectionné
 $objets = selectObjet($bdd,$idpere,$donnee,1);		// recherche objets visibles
 if ($objets != "") {
  echo '<table border="1"><tr>';			// affiche dans un tableau html
  echo gestiondoublonsLegende;
  $c = 0;
  $nbobjet = count($objets);
  for ($o=0;$o<$nbobjet;$o++) {
   echo '<tr>';
   $donnees = selectId($bdd,$objets[$o][0]);	
   afficheRangTable('','Id'.$o,'texte',5,$donnees[0],'Readonly','d');  
   afficheRangTable('','Texte'.$o,'texte',50,$donnees[3],'Readonly','d'); 
   afficheRangTable('','action'.$o,'select',10,$choix,'','d');
   echo '</tr>';
   $c++;
  }
  echo '</table><hr>';
  $mesrep = $c.' trouvés'; 
 } 
 else {
   $mesrep = gestiondoublonsAttention;	
 }
 $_POST['message'] = $mesrep;	// informe l'utilisateur
 if (isset($_POST['message']))
  afficheChamp('','message','text','100',$_POST['message'],'','Readonly');
 else
  afficheChamp('','message','text','100','','','Readonly');
 $eliminer = gestiondoublonsEliminer;
 echo ' &nbsp;<input type="submit" name="traiter" value="'.$eliminer.'" />';
 echo '</form>';  
}

// affiche ou ré-affiche le formulaire
 echo '<form method="POST" action="gestiondoublons.php">';
 echo gestiondoublonsTitre1;
 echo gestiondoublonsGuide1;
 if (isset($_POST['donnee'])) $valdonnee = $_POST['donnee'];
 else $valdonnee = "";
 echo '<table><tr>';
 afficheRangTable(gestiondoublonsDonnee,'donnee','text','50',$valdonnee,'','');
 $typeobjets = selectObjet($bdd,$IdRacObj,'%',0); // retrouve tous les types objets 
 $nbtype = count($typeobjets);
 for ($t=0;$t<$nbtype;$t++) {			// construit options des types d'objet
  $options[$t][0] = $typeobjets[$t][0];
  $options[$t][1] = $typeobjets[$t][1];
 }
  $options[$t][0] = '';				// ajoute type indéfini
  $options[$t][1] = gestiondoublonsIndef;
 echo '</tr><tr>'; 
 afficheRangTable(gestiondoublonsType,'type','select',80,$options,'','');
 echo '</tr></table><br>';
// affiche ligne message et bouton de soumission
 if (isset($_GET['message'])) $_POST['message'] = $_GET['message'];
 if (isset($_POST['message']))
  afficheChamp('','message','text','100',$_POST['message'],'','Readonly');
 else
  afficheChamp('','message','text','100','','','Readonly');
 $recherobjet = gestiondoublonsRecherObjet;
 echo '<hr><input type="submit" name="recher" value="'.$recherobjet.'" />';
 echo '</tr></table><br>';
 echo '<table<tr><br>';
 $typefiches = selectObjet($bdd,$IdRacFic,'%',0);// retrouve tous les types fiches 
 $nbtypef = count($typefiches);
 for ($t=0;$t<$nbtypef;$t++) {			// construit options des types de fiche
  $optionsf[$t][0] = $typefiches[$t][0];
  $optionsf[$t][1] = $typefiches[$t][1];
 }
 afficheRangTable(gestiondoublonsTypeF,'type','select',80,$optionsf,'','');
 echo '</tr></table><br><br>';
 // affiche ligne message et bouton de soumission
 if (isset($_GET['message'])) $_POST['message'] = $_GET['message'];
 if (isset($_POST['message']))
  afficheChamp('','message','text','100',$_POST['message'],'','Readonly');
 else
  afficheChamp('','message','text','100','','','Readonly');
 $recherfiche = gestiondoublonsRecherFiche;
 echo '<hr><input type="submit" name="traiterfiches" value="'.$recherfiche.'" />';
?>
 <script>
  document.getElementById('texte0').focus();
 </script>
<?php
 echo '</form>';
/* affiche pied de page */
include('lib/pied.php');
?>
