<?php
/* But de ce programme: Importer les données depuis différents formats
 entrées: format d'export (csv a plat, qif, ...)
 traitement: importer selon le format choisi
*** la présence de ' dans un libellé texte quelconque provoque une erreur d'insertion en base de données
** trier les lignes vcard sur la clé (important si GEO existe pour rattacher lat/long à adresse
* cas photo non traité
 */
// affiche entête Html, bannière personnalisée et menu dynamique
include('lib/ban-menu.php'); 
// inclue fonctions génériques (ici: ouvreBase et afficheChamp)
include('lib/lib.php');
autorise(array(5,9));			// contrôle accès autorisé pour admin et gestionnaire
// ouvre la base 
$bdd = ouvreBase();
initBase($bdd);

// crée table de correspondance entre Vcf code et objet contact
// détermine le traitement à appliquer (Rien=0, Simple=1, NomPrenom=2, Geo=3, Adresse=4, Photo=5
function creeTabCorrespondance($bdd) {
 global $tab,$erreur;
 $tab = array();
 $tab['ADR'] = array('Ligne adresse',0,4);
 $tab['ADR-1'] = array('Ligne adresse',0,0);
 $tab['ADR-2'] = array('Commune',0,0);
 $tab['ADR-3'] = array('Code postal',0,0);
 $tab['ADR-4'] = array('Pays',0,0);
 $tab['ANNIVERSARY'] = array('Anniversaire',0,1);
 $tab['BDAY'] = array('Anniversaire',0,1); 
 $tab['CATEGORIES'] = array('Métier',0,1);
 $tab['EMAIL'] = array('Email',0,1); 
 $tab['GEO'] = array('Latitude',0,3);
 $tab['GEO-1'] = array('Latitude',0,0);
 $tab['GEO-2'] = array('Longitude',0,0);
 $tab['N'] = array('Nom',0,2); 
 $tab['N-1'] = array('Nom',0,0);
 $tab['N-2'] = array('Prénom',0,0);
 $tab['NICKNAME'] = array('Surnom',0,1); 
 $tab['NOTE'] = array('Notes',0,1); 
 $tab['ORG'] = array('Société',0,1); 
 $tab['PHOTO'] = array('Photo',0,5); 
 $tab['ROLE'] = array('Métier',0,1); 
 $tab['TEL'] = array('Téléphone',0,1); 
 $tab['TITLE'] = array('Métier',0,1);
 $ctab = count($tab);
 $erreur = FALSE; 
 foreach ($tab as $key => $value) {
  $texte = $tab[$key][0];
  $cle = selectTexte($bdd,$texte,0); 
  if ($cle != NULL AND $cle > 0) {
   $tab[$key][1] = $cle;
  }
  else {
   echo '<br>'.$key.' n\'a pas de correspondant objet !';
   $erreur = TRUE;
  }
 }
// echo '<br>tab '; print_r($tab);
}

define ('TITRE','<h4>Import format csv</h4>');
define ('MODE_EMPLOI','<p class="mode-emploi">Mode d\'emploi:<br/>Entrer le nom du fichier à importer (dernier import effectué généralement).<br/>Appuyer sur le bouton <b>Importer</b><br/>Le programme analyse le fichier pour déterminer automatiquement son type csv; si non csv erreur !</p>');
define ('FICHIER','Nom du fichier import ');
define ('IMPORTER','Importer ');
define ('OPE_NON_ACCES','Erreur ! Accès fichier interdit !');

// Action d'importer
if (isset($_POST['importer']) ) {
//print_r($_POST);
// analyse et recherche du bon format 
 $formats = explode(".",$_POST['fichier']);
 $format = $formats[1];
 $_POST['message'] = "Début import au format ".$format;  
 if ($format == "csv") {
   try {
    $bdd->beginTransaction(); 		// ouvre une transaction
    $bdd->commit();   
   }
   catch(Exception $e) {
    $bdd->rollback();			// invalide la transaction
    $_POST['message'] = $e->getmessage();
   }
  }
  elseif ($format == "vcf") {
// construit table de correspondance
  creeTabCorrespondance($bdd);
  if ($erreur) {
   $_POST['message'] = "Erreur ! manque des objets.";  
  }
  else {
  // lit fichier, crée tableau
    $fichier = 'vcf/'.$_POST['fichier'];
    $tableau = array();
    $tableau = file($fichier);
    $ctableau = count($tableau);
    $table = array();
    $i = 0;
    for ($t=0;$t<$ctableau;$t++) {
     if (substr($tableau[$t],0,11) == 'BEGIN:VCARD') {
      $table[$i][0] = $t+1;
     }
     if (substr($tableau[$t],0,9) == 'END:VCARD') {
      $table[$i][1] = $t-1;
      $i++;
     }    
    }
    echo 'i= '.$i;
 // traitement de chaque Vcard
    try {
     $bdd->beginTransaction(); 				// ouvre une transaction
     $nbcontact = 0;
     $ficpere = selectTexte($bdd,'Fiche Contact',0); 
     for ($t=0;$t<20;$t++) {				// pour chaque contact
     echo 't= '.$t;
     // créer la fiche contact et récupérer son Id
      $idfiche = insertObjet($bdd,$ficpere,'##'.uniqid(),1);
      $nbcontact++;
      $ld = $table[$t][0];
      $lf = $table[$t][1];
      $nbl = $lf - $ld +1;
      echo '<br>';
      for ($l=$ld;$l<$ld+$nbl;$l++) {  			// pour chaque ligne Vcard du contact
       echo '<br>l='.$l.' '.$tableau[$l];
       foreach ($tab as $key => $value) {
        $lgkey = strlen($key);
        if (substr($tableau[$l],0,$lgkey) == $key) {
         $idpere = $value[1];
         $option = $value[2];
         if ($option == 1) {				// si cas simple
          $texte = explode(':',$tableau[$l]);
          $dern = count($texte) -1;
          $text = trim($texte[$dern]);
          $idocc = insertObjet($bdd,$idpere,$text,1);	// créer l'objet
          insertRelation($bdd,$idfiche,$idocc,1);	// créer la relation fiche à objet       
         }
         if ($option == 2) {				// si cas NomPrénom
          $texte = explode(':',$tableau[$l]);
          $nomprenom = explode(';',$texte[1]);
          if ($nomprenom[0] != "") {
           $nom = trim($nomprenom[0]);
           $idocc = insertObjet($bdd,$idpere,$nom,1);	// créer l'objet nom
           insertRelation($bdd,$idfiche,$idocc,1);	// créer la relation fiche à objet   
          }
          $idpere2 = $tab['N-2'][1];
          for ($p=1;$p<4;$p++) {
           $prenom = trim($nomprenom[$p]);
           if ($prenom != "") {
            $idocc = insertObjet($bdd,$idpere2,$prenom,1);// créer l'objet prénom
            insertRelation($bdd,$idfiche,$idocc,1);	// créer la relation fiche à objet
           }
          }       
         }
         if ($option == 3) {				// si cas coordonnées géographiques
         						// suppose que ADR a été lu auparavant !
          $texte = explode(':'.$tableau[$l]);
          $latlon = explode(';',$texte[1]);
          $idpere1 = $tab['GEO-1'][1];
          $latitude = trim($latlon[0]);
          $idocc = insertObjet($bdd,$idpere1,$latitude,1);// créer l'objet latitude
          insertRelation($bdd,$idficheadr,$idocc,1);	// créer la relation fiche à objet
          $idpere2 = $tab['GEO-2'][1];
          $longitude = trim($latlon[1]);
          $idocc = insertObjet($bdd,$idpere2,$longitude,1);// créer l'objet longitude
          insertRelation($bdd,$idficheadr,$idocc,1);	// créer la relation fiche à objet
         } 
         if ($option == 4) {				// si cas Adresse
          $ficpereadr = selectTexte($bdd,'Fiche adresse',0); 
          $idficheadr = insertObjet($bdd,$ficpereadr,'##'.uniqid(),1);  // crée fiche adresse
          insertRelation($bdd,$idfiche,$idficheadr,1);	// créer la relation fiche à fiche adresse
          $texte = explode(';',$tableau[$l]);
          if ($texte[3] != "") {
           $idperelig = $tab['ADR-1'][1];
           $text = trim($texte[3]);
           $idocc = insertObjet($bdd,$idperelig,$text,1);// créer l'objet ligne adresse
           insertRelation($bdd,$idficheadr,$idocc,1);	// créer la relation fiche adresse à ligne adresse
          }
          if ($texte[4] != "") {
           $idperecom = $tab['ADR-2'][1];
           $text = trim($texte[4]);
           $idocc = insertObjet($bdd,$idperecom,$text,1);// créer l'objet commune
           insertRelation($bdd,$idficheadr,$idocc,1);	// créer la relation fiche adresse à commune  
          }
          if ($texte[6] != "") {
           $idperepos = $tab['ADR-3'][1];
           $text = trim($texte[6]);
           $idocc = insertObjet($bdd,$idperepos,$text,1);// créer l'objet code postal
           insertRelation($bdd,$idficheadr,$idocc,1);	// créer la relation fiche adresse à code postal   
          }
          if ($texte[7] != "") {
           $idperepays = $tab['ADR-4'][1];
           $text = trim($texte[7]);
           $idocc = insertObjet($bdd,$idperepays,$text,1);// créer l'objet pays
           insertRelation($bdd,$idficheadr,$idocc,1);	// créer la relation fiche adresse à commune  
          }
         }
         if ($option == 5) {				// si cas Photo
         }       
        }
       }       
      }
     }
     $bdd->commit();   		// valide la transaction
     $_POST['message'] = $nbcontact.' ont été traités'; 
    }
    catch(Exception $e) {
    $bdd->rollback();			// invalide la transaction
    $_POST['message'] = $e->getmessage();
   }  
  }
 }
}

// Début du formulaire
 echo '<form method="POST" action="importdivers.php" >';
 echo TITRE;
 echo MODE_EMPLOI;
 echo '<a href="./aide/importdivers.html" target="_blank">Aide en ligne</a><br>';

 echo '<table><tr>';
// afficheRangTable(FICHIER,'fichier','text','20','monfichier',' ','','');
// attention: file retourne le nom du fichier seul sans son répertoire !!
 echo '<td><label>Nom du fichier importé </label><input type="file" name="fichier" size="100" /></td>';
 echo '</tr><tr>';
 afficheRangTable(IMPORTER,'importer','submit','3','Importer',' ','','');
 echo '</table><br/>';
 if (isset($_POST['message']))
  afficheChamp('','message','text','80',$_POST['message'],'','Readonly');
 else
  afficheChamp('','message','text','80','','','Readonly');
 echo '</form>';
// affiche pied de page 
include('lib/pied.php');
?>
