<?php
/* But de ce programme: Modifier ou supprimer une fiche existante
 Utilise la transaction pour valider (ou non) l'ensemble des mises à jour effectuées
 afin de modifier ou supprimer l'occ. de fiche 
 *** Prévoir un programme de suppression des objets orphelins (non pointés par une fiche)
 */
session_start(); 		// démarre la session
include('lib/lib.php'); 	// inclue fonctions génériques (ici: ouvreBase et afficheChamp)
$bdd = ouvreBase(); 		// ouvre la base de données ;
include('lib/ban-menu.php'); 	// affiche entête Html, bannière personnalisée et menu dynamique
autorise(array(0)); 		// contrôle accès autorisé par tous
initBase($bdd);			// récup $IdRacGen, $IdRacObj $IdRacFic et $IdRacRel

function ficherenseignee($bdd,$c,$idg) {
/* indique si au moins un champ de la fiche est renseigné ou si la fiche est vide
$idg est l'idpere de l'occ. de fiche à créer
$c est le pointeur dans $_POST
retourne 0 si renseigné, retourne nb champs à sauter si non renseigné 
*/
 $composants = selectComposant($bdd,$idg);// recherche composants de la fiche générique
 $nb = count($composants);		
 $imax = $c+$nb+1;			// pointeur max dans $_POST
 $rens = $nb;				// fiche à priori vide
 for ($i=$c+1;$i<$imax;$i++) {
  $val = $_POST['texte'.$i];
  if ($val !="") {			// si existe un champ renseigné
   $rens = 0;
   break;
  }
 }
 return $rens;
}

/* La suppression d'une fiche entraîne la suppression de toutes ses relations fiche -> objet ;
   par contre aucun objet de l'ancienne fiche n'est supprimé car ces objets peuvent être utilisés par d'autres fiches
   et les objets orphelins de fiche sont réutilisables lors de la création de nouvelles fiches. 
*** Si nécessaire faire un programme de suppression des orphelins d0objet.php
** en suppression doit supprimer les relations en cascade, du moins si non utilisé par autre relation
   en modification modifier tous les objets de la fiche ainsi que ceux de la sous fiche (une seule sous fiche, pas de sous sous fiche)
*/
if (isset($_POST['supprimer']) ) {			// si appui sur bouton supprimer
 $poubelle = array_pop($_POST); 			// éliminer le post du supprimer
 $poubelle = array_pop($_POST); 			// éliminer le post du message
 try {
  $bdd->beginTransaction(); 				// ouvre une transaction
  $idfiche = intval($_POST['fiche']);
  $composants = selectComposant($bdd,$idfiche);		// trouve composants	
  $nbc = count($composants);
  for ($c=0;$c<$nbc;$c++) {				// pour chaque composant
   $idc = $composants[$c][0];
   $pereidc = selectIdPere($bdd,$idc);
   $idx = selectIdPere($bdd,$pereidc);
   if ($idx == $IdRacFic) {				// si composant est une fiche ...
    deleteObjet($bdd,$idc);				// ... supprime la sous fiche et ses relations
   }
  }
  deleteObjet($bdd,$idfiche);				// supprime la fiche et ses relations objet
// si l'objet de clé id est supprimé, la relation de IdCompose = id est supprimée (contrainte cascading), et 
// la relation de IdComposant = id est également supprimée (contrainte cascading) 
// mais ne supprime pas les objets ni la sous fiche
  $bdd->commit(); 					// valide et termine la transaction
  $suppression = TRUE;
// informe l'utilisateur
  $_POST['message'] = 'Fiche N° '.$idfiche.' supprimée. Retour au menu pour autre action.';
 }
 catch(Exception $e) {
  $bdd->rollback();						// invalide la transaction
  $_POST['message'] = 'Erreur ! Rien n\'a été supprimé !';
 }
}

/* La modification des objets d'une fiche garde cette fiche mais détruit toutes les relations fiche -> objet anciennes.
   Les objets modifiés sont en réalité re-créés. 
   Les anciens objets non modifiés sont gardés d'autant plus qu'ils peuvent être utilisés par d'autres fiches.  
   De nouvelles relations fiche -> objet/fiche sont crées pour chaque objet modifié
   S'il existe une sous fiche elle doit être seule et la dernière dans la structure  */
if (isset($_POST['modifier']) ) {		// si appui sur bouton Modifier
 $poubelle = array_pop($_POST); 		// éliminer le post du modifier 
 $poubelle = array_pop($_POST); 		// éliminer le post du message 
 $cmax = (count($_POST)/2)-1;
//print_r($_POST); echo '<br>cmax='.$cmax;
 try {
  $bdd->beginTransaction(); 				// ouvre une transaction
  $idfiche = $_POST['fiche'];				// id fiche inchangée
  $perefiche = selectIdPere($bdd,$idfiche);		// id de la fiche générique
  $composants = selectComposant($bdd,$idfiche);		// trouve composants	
  $nbc = count($composants);
  for ($c=0;$c<$nbc;$c++) {				// pour chaque composant
   $idc = $composants[$c][0];
   $pereidc = selectIdPere($bdd,$idc);
   $idx = selectIdPere($bdd,$pereidc);
   if ($idx == $IdRacFic) {				// si composant est une fiche ...
    deleteObjet($bdd,$idc);				// ... supprime la sous fiche et ses relations
   }
  }
  deleteComposant($bdd,$idfiche);			// supprime les relations objets de la fiche
// crée les occ. objet modifiées et recrée toutes les relations
  $idficheprincipale = $idfiche;		// sauvegarde id fiche principale
// crée les occ. objet (Idpere = $_POST['texte'.$c, Texte= $_POST['texte'.$d], visible = 1) et les relations
  $ctr = 0;
  for ($c=0;$c<$cmax;$c++) {				// pour tous les couples de $_POST
   $valobjet = $_POST['texte'.$c];
   $pereobjet = intval($_POST['idpere'.$c]);		// lit IdPere du champ/fiche  
   $idx = selectIdPere($bdd,$pereobjet);		// recherche Idpere de l'objet/fiche 
   if ($idx == $IdRacFic) { 				// si c'est une occ. de fiche
    $result = ficherenseignee($bdd,$c,$pereobjet);
    if ($result == 0) {					// si un champ de cette sous fiche est renseigné 
 /* compléter le ## de $_POST['texte'.$d] par un uuid unique (contrainte clé candidate) */
      $unique = "##".uniqid();
      $idsousfiche = insertObjet($bdd,$pereobjet,$unique,1);   // crée l'occ sous fiche visible   
      insertRelation($bdd,$idficheprincipale,$idsousfiche,1);	// crée relation ficheprincipale -> sous fiche (*)
 // (*) les sous fiches de sous fiches ne sont pas gérées
      $ctr++; 
      $idfiche = $idsousfiche;  // récupère le id de la sous fiche créée pour les futures relations fiche -> objet
    }
    else { 	// si sous fiche considérée comme non renseignée sauter tous les autres champs de la fiche 
 // retrouve le nombre de champs de cette sous fiche et avance le curseur c de la valeur de ce nombre
     $c = $c+$nb;
    }
   }
   elseif ($idx == $IdRacObj) {			// si c'est une occ. d'objet  
    if ($valobjet != "") {			// si la valeur du champ a été renseignée
// le premier terme est IdPere,l'Id du champ générique et le deuxième est la valeur de l'objet
     $idobjet = insertObjet($bdd,$pereobjet,$valobjet,1); // crée l'occ objet visible 
     insertRelation($bdd,$idfiche,$idobjet,1);		// crée relation fiche -> objet
     $ctr++; 
    }
   }
  }
  if ($ctr == 0)	{		// si la fiche est vide, la supprimer
   $bdd->rollback;
   $_POST['message'] = 'Erreur ! Fiche vide non créée';
  }
  else {
   $bdd->commit(); // INvalide la transaction et informe l'utilisateur
   $_POST['message'] = 'Fiche N° '.$idfiche.' créée';   
  }
 } 
 catch(Exception $e) {
  $bdd->rollback();	// invalide la transaction
  $_POST['message'] = 'Erreur ! Rien n\'a été modifié !';
 }
} 

// affiche ou ré-affiche le formulaire de modification des données
echo '<form method="POST" action="m2fiche.php">';
// affiche champs de saisie, ligne message et bouton de soumission
// recherche les labels des champs de contact
// trouve les types d'objet dont IdPere = IdRacObj
///$tablabel = selectObjet($bdd,'',$IdRacObj,'');
///$imax = count($tablabel);
// recherche les données d'après N° de fiche
// trouve les Id des données
if (isset($_GET['fiche'])) {				// si n° de fiche passé dans l'url
 $fiche = $_GET['fiche'];
} 
else {
 $fiche = $_POST['fiche'];	
}
$mode = 2;						// préparer la saisie/modification
if ($suppression) {
 afficheChamp('','message','text','100',$_POST['message'],'','Readonly');
}
else {
 $options = selectNom($bdd,$fiche);
 $idpere = $options[1];					// lit id de la fiche générique
 $donnees = selectNom($bdd,$idpere);
 $libfiche = $donnees[0];				// lit nom générique de la fiche
 echo '<h4>Modification ou suppression d\'une '.$libfiche.'</h4>';
 echo '<table>';
 afficheForme($bdd,$idpere,$mode,$fiche);		// lance affichage 
 echo '</table>';
 echo '<input type="hidden" name="fiche" value="'.$fiche.'">'; // passer n° de fiche
 echo '<input type="hidden" name="libfiche" value ="'.$libfiche.'" />';
 if (isset($_POST['message']))
  afficheChamp('','message','text','100',$_POST['message'],'','Readonly');
 else
  afficheChamp('','message','text','100','','','Readonly');
 echo '<hr><input type="submit" name="modifier" value="Modifier" />';
 echo '&nbsp;<input type="submit" name="supprimer" value="Supprimer" />';
//echo '&nbsp;<input type="submit" name="retoursaisie" value="Sélectionner cette fiche pour la saisie en cours" />';
?>
<script>
 document.getElementById('texte0').focus();
</script>
<?php
}
 echo '</form>';
include('lib/pied.php');		/* affiche pied de page */
?>
