<?php
/* But de ce programme: Rechercher des fiches selon critères
 Les critères sont tout ou partie du nom de données définies pour une fiche seule ou deux fiches en relation
 Par exemple on peut rechercher des fiches adresses seulement selon le renseignement de données adresse,
 ou bien des fiches contact selon le renseignement de données contact et de données adresse
 On peut faire une recherche de proximité pour une longitude et une latitude données en précisant un écart en kms
 On peut réaliser un OU logique ou bien un ET logique entre ces critères
 On peut spécifier la sensibilité à la casse ou non et utiliser le joker %
 En retour, affiche un tableau numéroté de liens sur les fiches trouvées avec visu de deux données principales;
 En cliquant sur le lien, visualise la fiche et permet de la modifier ou supprimer (sous conditions par m2fiche)
 Dernière mise à jour: 11/12/2024
  Attention: les IdPere Longitude et Latitude sont fixés en dur (adapté à appli contact)
  
 ?? erreur n'affiche pas le n° de téléphone après un importdivers ; liens dans relation corrects !! 
*/
if (!isset($_SESSION)) session_start(); // démarre la session
include('lib/lib.php'); 		// inclue fonctions génériques (ici: ouvreBase et afficheChamp)
$bdd = ouvreBase(); 			// ouvre la base de données ;
include('lib/ban-menu.php'); 		// affiche entête Html, bannière personnalisée et menu dynamique
// contrôle accès autorisé à tous
autorise(array(0));
initBase($bdd);				// récup $IdRacGen, $IdRacObj $IdRacFic et $IdRacRel

DEFINE ('r2ficheLegende','<br><b>Fiches trouvées et numérotées</b></br><br>');
DEFINE ('r2ficheTrouves',' trouvée(s)');
DEFINE ('r2ficheAucun','Attention ! Aucune fiche trouvée selon ces critères ! Ajouter ou modifier un critère ? Changer condition entre critères ?');
DEFINE ('r2ficheNonRenseigne','Erreur ! Renseigner au moins un critère de recherche !');
DEFINE ('r2ficheTitre','<h4>Recherche données par fiche</h4>');
DEFINE ('r2ficheChoix','Choix');
DEFINE ('r2ficheValider','Valider choix');
DEFINE ('r2ficheTitre1','<h4>Recherche données selon fiche '.$_SESSION['libfiche'].'</h4>');
DEFINE ('r2ficheGuide1',"<p>Utiliser le % comme joker pour sélectionner les <b>champs textuels</b><br/>Exemple1: c% retrouve toute expression commençant par lettre c.<br>Exemple2: %ol% retrouve toute expression contenant ol. Exemple3: %ian retrouve toute expression finissant par ian.<br/>On peut combiner; la recherche est sensible ou non à la casse et aux accents.<br><br>Utiliser le = < <= > >= et les quôtes simples ainsi que le ET pour sélectionner des <b>champs numériques</b><br>Exemple1: >'7.1' retrouve tout nombre supérieur à 7.1 Exemple2: >'5.3' ET <='7' retouve tout nombre supérieur à 5.3 et inférieur ou égal à 7.<br><br><b>On peut combiner les différents critères par un OU logique (inclusion) ou un ET logique (exclusion).<b><br></p>");
DEFINE ('r2ficheRechercher','Rechercher');
DEFINE ('r2ficheCasse','Recherche sensible à la casse');
DEFINE ('r2ficheBooleen','Condition entre critères');

$nf =  0;		// nombre de fiches utilisées pour la recherche
$nc0 = 0;		// nombre de couples idpere,texte pour la fiche 0
$nc1 = 0 ;		// nombre de couples idpere,texte pour la fiche 1
$tabId = array(); 

// retrouve les IdPere des 2 critères à afficher en liste html
function retrouveIdPereAffiche($bdd,$idrefer) {
 global $idobjetaff1,$idobjetaff2;
 $composants = selectComposant($bdd,$idrefer);
 if (isset($composants)) {
  $idobjetaff1 = $composants[0][0];
  $idobjetaff2 = $composants[1][0];
 }
 else
  die('Fiche de Id='.$idrefer.' sans composants ! Erreur fatale');
}

// détermine s'il y a une ou deux fiches dans le formulaire et si critère renseigné
function determineNbFiches($bdd) {
 global $nf,$nc0,$nc1,$IdRacFic;
 $pmax = count($_POST) - 3;
 $nf = 0;
 $renseigne = FALSE;
 for ($i=0;$i<$pmax;$i++) {
  if ($i%2 == 0) {
   $j = $i/2; 
   $idpere = $_POST['idpere'.$j];  		// lit type du critère ex: 5 (type Nom)
   $libelle = $_POST['texte'.$j];
   if ($libelle != "")  $renseigne = TRUE;
   $idgpere = selectIdPere($bdd,$idpere); 	// lit son supertype
   if ($idgpere == $IdRacFic) {// si supertype = racine des fiches et critère renseigné
    $nf = 2;
    $nc0 = $i/2;
    $nc1 = ($pmax - $i-1)/2;
    $i++;
   }
  }
 }
 if (!$renseigne)	// si aucun critère renseigné
  $nf = -1;
 else {
  if ($nf == 0) {
   $nf = 1;
   $nc0 = $pmax/2;
  }
 }
}

// recherche les Id des fiches à partir des données 
// exécute une réunion ou une intersection logique de ces Id
function rechercheFiches($bdd,$f,$c,$cmax,$casse,$condition) { 
// $c n° du champ dans le Post 0=nom, 1 = Prénom, ... 11 = Ligne adresse ...
 unset($tabId[$f]); 
 $tabIdf = array();
 for ($i=$c;$i<$cmax;$i++) {
  $idpere = $_POST['idpere'.$i];
  $libelle = $_POST['texte'.$i];
  if (isset($libelle) AND $libelle !="" ) {
    $tabIdf = selectFiches($bdd,$idpere,$libelle,$casse,0);
   if (isset($tabIdf)) {
    if ($condition == 0) {
     $tabId[$f] = array_merge($tabIdf);
    }
    else {
     if (isset($tabId[$f])) {
      if (isset($tabIdf))
       $tabId[$f] = array_intersect($tabIdf,$tabId[$f]);
     }
     else
      $tabId[$f] = $tabIdf;
    }
   }
  }
 }
 return $tabId[$f]; 
}

// sous programme d'affichage du message de retour ou d'erreur
function afficheMessage() {
// affiche ligne message et bouton de soumission
 if (isset($_POST['message']))
  afficheChamp('','message','text','100',$_POST['message'],'','Readonly');
 else
  afficheChamp('','message','text','100','','','Readonly');
}

if (isset($_POST['choix']) ) {				// Choix d'un type de fiche effectué
 $_SESSION['idfiche'] = $_POST['fiche'];		// Récupère son id
 $fiches = selectId($bdd,$_POST['fiche']);		// Recherche son libellé
 $_SESSION['libfiche'] = $fiches[3];
 $_POST['message'] = ""; 
}

if (isset($_POST['terminer']) ) {					// Demande autre choix
 unset($_SESSION['fiche']);					// supprime variable de session pour réinit process.
 die('fin de la recherche');
 $_POST['message'] = "";
}

// début de la recherche
// ------------------------------
if (isset($_POST['recher']) ) {		// Submit de recherche effectué
 $poubelle = array_pop($_POST); 	// éliminer le post du message
 $poubelle = array_pop($_POST); 	// éliminer le post du recher
//print_r($_POST);
 $casse =  $_POST['casse']; 
 $condition = $_POST['condition'];
 
// détermine si une ou deux fiches dans le formulaire de recherche et si un critère renseigné
 determineNbFiches($bdd);
 if ($nf != -1) {			// si au moins un critère renseigné
 $idrefer = $_SESSION['idfiche']; 	// récup de la fiche de référence
 retrouveIdPereAffiche($bdd,$idrefer);	// retrouve IdPere des objets affichés par la recherche
// -------- traitement première fiche ---------
 $tabIdA = array();
 $f = 0;
 $c = 0;
 $tabIdA[0] = rechercheFiches($bdd,$f,$c,$nc0,$casse,$condition);
 if (isset($tabIdA[0])) {
  $nbtabId0 = count($tabIdA[0]);	
  if ($nbtabId0 > 0) {
   $tabIdA[0] = array_unique($tabIdA[0]);// élimine doublons éventuels
   $tabIdA[0] = array_values($tabIdA[0]);
   $nbtabId0 = count($tabIdA[0]);
  }
 }
 else
  $nbtabId0 = 0;
 if ($nf > 1) {
// ------ traitement seconde fiche (liée à la première par relation amont)
  $tabId = array();
  $f = 1;
  $c=$nc0 + 1;
  $cmax = $nc0+$nc1;
  $tabId[1] = rechercheFiches($bdd,$f,$c,$cmax,$casse,$condition);
  if (isset($tabId[1])) {
   $nbtabId1 = count($tabId[1]);			
   if ($nbtabId1 > 0) {
    $tabId[1] = array_unique($tabId[1]);			// élimine doublons éventuels
    $tabId[1] = array_values($tabId[1]);
    $nbtabId1 = count($tabId[1]);
   }
// pour chaque Id de fiche trouvée, recherche sa ou ses fiches amont
// si la fiche amont est de même type que la fiche de référence, la mémoriser
   $na = 0;
   $tabAmont = array();
   for ($i=0;$i<$nbtabId1;$i++) {
    $idcomposant = $tabId[1][$i];
    unset($tabAmont);
    $tabAmont = selectCompose($bdd,$idcomposant);
    $jmax = count($tabAmont); 
    for ($j=0;$j<$jmax;$j++) {
     $id = $tabAmont[$j][0];
     $idpereAmont = selectIdPere($bdd,$id);
     if ($idpereAmont == $idrefer) {
      $tabIdA[1][$na] = $id;
      $na++;
     }
    }
   }
   $nbIdA = count($tabIdA[1]);
  } 
 }

// selon la condition fait la réunion ou l'intersection logique entre les fiches trouvées
 $nbIda0 = $nbIda1 = 0;
 if (isset($tabIdA[0])) $nbIda0 = count($tabIdA[0]);
 if (isset($tabIdA[1])) $nbIda1 = count($tabIdA[1]);
 if ($condition == 0) {
  if ($nbIda0 == 0 AND $nbIda1 > 0 )
   $tableId = $tabIdA[1];
  elseif ($nbIda1 == 0 AND $nbIda0 > 0 )
   $tableId = $tabIdA[0];  
  elseif ($nbIda0 > 0 AND $nbIda1 > 0)   
   $tableId = array_merge($tabIdA[0],$tabIdA[1]);
  else
   $tableId = array();
 }
 elseif ($condition == 1) {
  if ($nbIda0 > 0 AND $nbIda1 > 0)
   $tableId = array_intersect($tabIdA[0],$tabIdA[1]);
  elseif ($nbIda1 == 0 AND $nbIda0 > 0 )
   $tableId = $tabIdA[0]; 
  elseif ($nbIda0 > 0 AND $nbIda1 > 0)   
   $tableId = array_merge($tabIdA[0],$tabIdA[1]); 
  else
   $tableId = array();
 }

// Elimine les doublons éventuels et reconstruit les clés ordonnées  
  if (isset($tableId)) {
   $tableId = array_unique($tableId);			
   $tableId = array_values($tableId);
   $imaxf = count($tableId);
  }
  else
   $imaxf = 0;
 if ($imaxf > 0) {		// si au moins une fiche trouvée 
// affichage du tableau html des fiches trouvées
   echo r2ficheLegende;  
   echo '<table border="1">';			
   $nbcol = $nbcolmax;
   if ($imaxf <= $nbcol)
    $nblig = 1;
   else
    $nblig = Intval($imaxf/$nbcol);
   $modulo = $imaxf%$nbcol;
   if ($modulo != 0) $nblig++;
   $indice=0;
   for ($lig=0;$lig<$nblig;$lig++) {
    echo '<tr>';
    for ($col=0;$col<$nbcol;$col++) {
     if ($indice<$imaxf) {
      $nn = $indice+1;  
      $composantcs = array();
      $composantcs = selectComposant($bdd,$tableId[$indice]);
      if (isset($composantcs)) {
       $nbcomposantcs = count($composantcs); 
       $objetaff1 = "";		// première info affichée
       $objetaff2 = "";		// deuxième info affichée
       for ($i=0;$i<$nbcomposantcs;$i++) {
        $infoaffs = selectNom($bdd,$composantcs[$i][0]);
        if ($infoaffs[1] == $idobjetaff1) 
          $objetaff1 =  $objetaff1.' '.$infoaffs[0];
        if ($infoaffs[1] == $idobjetaff2)
         $objetaff2 = $objetaff2.' '.$infoaffs[0];
       }
       if ((strlen($objetaff1) < 4) AND (strlen($objetaff2) < 4))
        $objetaffiche = 'fiche';  
       else
        $objetaffiche =  $objetaff1.' '.$objetaff2;
      }      
      $nomgenerique = $nn.' '.$objetaffiche;
      echo '<td><a href="m2fiche.php?fiche='.$tableId[$indice].'" target="_blank">'.$nomgenerique.'</a></td>';
      $indice++;
      if ($iindice == $imaxf) {
       echo '</tr><td> ... </td><tr>';
      }
     }
    }
    echo '</tr>';
   }   
   echo '</table><hr>';
   $mesrep = $imaxf.r2ficheTrouves;	// affiche nombre des fiches trouvées
  } 
  else {
   $mesrep = r2ficheAucun;			// aucune fiche trouvée
  }
 }
 else {
  $mesrep = r2ficheNonRenseigne;		// aucun critère renseigné
 }
 $_POST['message'] = $mesrep;			// informe l'utilisateur
} // fin de la recherche

// affiche ou ré-affiche le formulaire de saisie des données
// ---------------------------------------------------------
 echo '<form method="POST" action="r2fiche.php">';
if (isset($_GET['fiche'])) {			// lancement avec paramètre n° de fiche
 $_POST['fiche'] = $_GET['fiche'];
}
if (count($_POST) == 0 ) {			// lancement initial sans paramètre (cas choix)	
 echo r2ficheTitre;
 $tabl = selectObjet($bdd,$IdRacFic,'%',0); 	// recherche des fiches de la racine des objets (vcard = NULL)
 $imax = count($tabl);
 for ($i=0;$i<$imax;$i++) {			// construit table des options du sélect
  $options[$i][0] = $tabl[$i][0];
  $options[$i][1] = $tabl[$i][1];
 }
 echo '<table><tr>';
 afficheRangTable(r2ficheChoix,'fiche','select','80',$options,'','');	// affiche champ sélection d'un type de fiche
 echo '</tr></table><br>';
 afficheMessage();
 $valider = r2ficheValider;
 echo '<hr><input type="submit" name="choix" value="'.$valider.'" />';	// affiche bouton submit de choix d'un type (choix)
}
else {						// affiche champs de la fiche
 $fiches = selectId($bdd,$_SESSION['idfiche']);// Recherche son libellé 
// $fiches = selectId($bdd,$_POST['fiche']);// Recherche son libellé
 $_SESSION['libfiche'] = $fiches[3];
 echo r2ficheTitre1;	// pour le type de fiche sélectionné
 echo r2ficheGuide1;
  $mode = 0; 					// mode recherche
  $c = 0;					// pointeur des couples(mode=0) du $_POST
  if (isset($_SESSION['idfiche'])) {
   echo '<table>';
   afficheForme($bdd,$_SESSION['idfiche'],$mode,0);	// affiche labels et champs de la fiche sélectionnée
///   echo '</tr><tr>';
///   afficheRangTable(r2ficheEcart,'ecart','text','20',$ecart,'','');
    echo '</tr><tr>';
   // Recherche avec ou sans casse
   $casses[0][0] = 1;
   $casses[0][1] = "Non";
   $casses[1][0] = 0;
   $casses[1][1] = "Oui";
   if (isset($casse))
    $casses[0][2] = $casse;
   else
    $casse = '';
   afficheRangTable(r2ficheCasse,'casse','select','80',$casses,'','');
   echo '</tr><tr>';
   // Recherche avec condition
   $conditions[0][0] = 0;
   $conditions[0][1] = "Ou logique";
   $conditions[1][0] = 1;
   $conditions[1][1] = "Et logique";
   if (isset($condition))
    $conditions[0][2] = $condition;
   else
    $condition = '';
   afficheRangTable(r2ficheBooleen,'condition','select','80',$conditions,'','');
   echo '</tr></table>';
  }
  echo '<br>'; afficheMessage();
  $rechercher = r2ficheRechercher;
  echo '<hr><input type="submit" name="recher" value="'.$rechercher.'" />';	// affiche bouton de recherche 							
}
?>
 <script>
  document.getElementById('texte0').focus();
 </script>
<?php
 echo '</form>';

/* affiche pied de page */
include('lib/pied.php');
?>
