<?php
// Dernière mise à jour: 24/072024
/* But de ce programme: Rechercher des occ. objet selon le type de donnée
 Affiche un tableau des données et des fiches trouvées, selon critère entré, type de donnée et casse ou non casse
 Dans relation on remonte sur la fiche et la fiche amont si elle existe
 *** il faudrait remplacer par une séquence récursive pour ne pas être limité à 2 niveaux de fiche
 Donne la possibilité, 
  d'éditer ou supprimer une occ. objet identifiée par son lien m2objet.php
  d'éditer ou supprimer une occ. de fiche identifiée par son lien m2fiche.php
 ** activer le code avec uid des fiches si nécessaire.
*/
if (!isset($_SESSION)) session_start(); 		// démarre la session
//error_reporting(E_ALL & ~E_NOTICE & ~E_WARNING);	// invalide erreur NOTICE et WARNING
include('lib/lib.php'); 				// inclue fonctions génériques (ici: ouvreBase et afficheChamp)
$bdd = ouvreBase(); 					// ouvre la base de données ;
include('lib/ban-menu.php'); 				// affiche entête Html, bannière personnalisée et menu dynamique
// contrôle accès autorisé à tous
autorise(array(0));
initBase($bdd);				// récup $IdRacGen, $IdRacObj $IdRacFic et $IdRacRel

DEFINE ('r2objetLegende','<th>Désignation objet</th><th colspan="10">Fiche(s) associée(s)</th></tr>');
DEFINE ('r2objetAucun','Attention ! Aucune donnée trouvée !');
DEFINE ('r2objetTrouves',' trouvés');
DEFINE ('r2objetDetype','de type ');
DEFINE ('r2objetIndef','de type non défini');
DEFINE ('r2objetTitre','<h4>Recherche par type de données');
DEFINE ('r2objetGuide','<p>Entrer une chaine de caractères et sélectionner un type de donnée.<br/>Utiliser le % comme joker pour sélectionner<br/>Exemple1: c% retrouve toute expression commençant par lettre c<br/>Exemple2: %ol% retrouve toute expression contenant ol<br/>Exemple3: %ian retrouve toute expression finissant par ian<br/>On peut combiner; par défaut, la recherche n\'est pas sensible à la casse ni aux accents<br/><br/>En retour un tableau des objets trouvés est affiché.<br/>Le lien Id permet de modifier ou supprimer la donnée.<br/>Le lien fiche associée permet de visualiser la fiche et de la modifier ou même supprimer si nécessaire.</p>');
DEFINE ('r2objetDonnee','Donnée recherchée ');
DEFINE ('r2objetType','Type de donnée ');
DEFINE ('r2objetRechercher','Rechercher');
DEFINE ('r2objetErreur','Erreur ! Critère de recherche non renseigné');
DEFINE ('r2objetCasse','Recherche sensible à la casse');

if (isset($_POST['recher']) ) {				// Submit de recherche effectué
 $poubelle = array_pop($_POST); 			// éliminer le post du recher
 $poubelle = array_pop($_POST); 			// éliminer le post du message
 $donnee = $_POST['donnee'];
 $casse = $_POST['casse'];
 if ($donnee == "") {					// si critère non renseigné, erreur
  $mesrep = r2objetErreur;	
 }
 else {
  $idpere = $_POST['type'];				// récupère type de l'objet
  $savidpere = $idpere;
// rechercher toutes les occurrences du type d'objet sélectionné
  if ($casse == 1)
   $objets = selectObjet($bdd,$idpere,$donnee,1);	// recherche objets visibles casse active
  else
   $objets = selectObjetci($bdd,$idpere,$donnee,1);	// recherche objets visibles casse inactive
  if ($objets != "") {
   echo '<table border="1"><tr>';			// affiche dans un tableau html
   echo r2objetLegende;
   $c = 0;
   $nbobjet = count($objets);
   for ($o=0;$o<$nbobjet;$o++) {
    print '<tr>';
    $donnees = selectNom($bdd,$objets[$o][0]);	
    $nomobjet = $donnees[0];			// lit le nom de la donnée et affiche
    $idpere = $donnees[1];			// lit l'IdPere de l'objet
    
    $types = selectIdType($bdd,$idpere);	// lit l'objettype du pere de l'objet
    if ($types[4] != "fiche") {		// ne pas afficher les noms de fiche en colonne données
     print '<td><a href="m2objet.php?objet='.$objets[$o][0].'" target="_blank">'.$nomobjet.'</a></td>';     
// retrouver la ou les fiches à laquelle appartient cette donnée
     $fiches = selectCompose($bdd,$objets[$o][0]);
     if ($fiches != "") {			// si au moins une fiche trouvée
      $fmax = count($fiches);
      for ($f=0;$f<$fmax;$f++) {			// pour chaque fiche
       $g = $f+1;
       $fiche = $fiches[$f][0];			// lit Id de la fiche
       $donnees = selectNom($bdd,$fiche);		
       $idpere = $donnees[1];			// lit le IdPere de la fiche
       $nomfic = $donnees[0];			// lit uuid de la fiche
       $donperes = selectNom($bdd,$idpere);
//       $nomfiche = $donperes[0].' '.$nomfic;	// lit nom générique fiche, ajoute uuid et affiche
       $nomfiche = $donperes[0];
       print '<td><a href="m2fiche.php?fiche='.$fiche.'" target="_blank">'.$nomfiche.'</a></td>';	// lien vers fiche
// retrouve les fiches amont s'il y en a (à remplacer par récursivité)
       $fiches1 = selectCompose($bdd,$fiche);
       if ($fiches1 != "") {				// si au moins une fiche trouvée
        $f1max = count($fiches1);   
        for ($f1=0;$f1<$f1max;$f1++) {			// pour chaque fiche
         $fiche1 = $fiches1[$f1][0];			// lit Id de la fiche
         $donnees = selectNom($bdd,$fiche1);		
         $idpere = $donnees[1];				// lit le IdPere de la fiche
         $nomfic1 = $donnees[0];				// lit uuid de la fiche
         $donnees = selectNom($bdd,$idpere);
 //        $nomfiche1 = $donnees[0].' '.$nomfic1;		// lit nom générique fiche, ajoute n° et affiche
         $nomfiche1 = $donnees[0];
         print '<td><a href="m2fiche.php?fiche='.$fiche1.'" target="_blank">'.$nomfiche1.'</a></td>';	// lien vers fiche     
        }
       }
      }
     }
     $c++;     
    } 
    else {
////     print '<td></td>';	// pas de fiche associée
    }
    print '</tr>';
   }
   echo '</table><hr>';
   $mesrep = $c.r2objetTrouves; 
  } 
  else {
   $mesrep = r2objetAucun;	
  }
 }
 $_POST['message'] = $mesrep;							// informe l'utilisateur
}

// affiche ou ré-affiche le formulaire de saisie des données
// ---------------------------------------------------------
 echo '<form method="POST" action="r2objet.php">';
 if (isset($_POST['type'])) {
  if ($_POST['type'] != '') {
   $infos = selectId($bdd,$_POST['type']);
   $info = r2objetDetype.$infos[2];
  }
  else
   $info = r2objetIndef;
 }
 else $info = '';
 echo r2objetTitre.$info.'</h4>';
 echo r2objetGuide;
 if (isset($_POST['donnee'])) $valdonnee = $_POST['donnee'];
 else $valdonnee = "";
 echo '<table><tr>';
 afficheRangTable(r2objetDonnee,'donnee','text','50',$valdonnee,'','');
// retrouver tous les types objets 
 $typeobjets = selectObjet($bdd,$IdRacObj,'%',0);
 $nbtype = count($typeobjets);
 for ($t=0;$t<$nbtype;$t++) {
  $options[$t][0] = $typeobjets[$t][0];
  $options[$t][1] = $typeobjets[$t][1];
 }
 if (isset($savidpere))
  $options[0][2] = $savidpere;
 else
  $options[0][2] = '';
// Recherche avec ou sans casse
 $casses[0][0] = 0;
 $casses[0][1] = "Non";
 $casses[1][0] = 1;
 $casses[1][1] = "Oui";
 if (isset($casse))
  $casses[0][2] = $casse;
 else
  $casse = '';
// ajouter type indéfini
  $options[$t][0] = '';
  $options[$t][1] = r2objetIndef;
 echo '</tr><tr>'; 
 afficheRangTable(r2objetType,'type','select',80,$options,'','');
 echo '</tr><tr>'; 
 afficheRangTable(r2objetCasse,'casse','select',8,$casses,'','');
 echo '</tr></table><br>';
// affiche ligne message et bouton de soumission
 if (isset($_GET['message'])) $_POST['message'] = $_GET['message'];
 if (isset($_POST['message']))
  afficheChamp('','message','text','100',$_POST['message'],'','Readonly');
 else
  afficheChamp('','message','text','100','','','Readonly');
  $rechercher = r2objetRechercher;
  echo '<hr><input type="submit" name="recher" value="'.$rechercher.'" />';
?>
 <script>
  document.getElementById('texte0').focus();
 </script>
<?php
 echo '</form>';

/* affiche pied de page */
include('lib/pied.php');
?>
