<?php
// Erreurs, anomalies, remarques
/* **** utiliser $data = htmlentities($_POST[]) pour protéger des attaques Html
Pas de solution implémentée */
/* But de ce programme: Définir une nouvelle fiche (de saisie)
 Il s’agit de créer :
 une occurrence générique de cette fiche dont le père est la racine de toutes les fiches
 pour créer cette fiche générique, il faut définir les objets génériques à lui rattacher mais aussi
 les sous fiches génériques éventuelles.
 Exemple: pour la fiche agenda, on définit les objets nom de personne, prénom, téléphone, email
 mais aussi la sous fiche adresse qui définit ligne adresse, commune, code postal et pays
 La notion de sous fiche est nécessaire afin de pouvoir relier sans ambiguïté les lignes adresses, commune, 
 code postal et pays propres à cette fiche adresse. Si chacun des contacts n'a qu'une adresse, la sous fiche adresse est inutile.
 *** Reste à faire: vérifier s'il existe une fiche doublon associant les mêmes objets ou fiches génériques et dans les mêmes répétitions. Si un
 facteur de répétition change, le doublon est autorisé (sous un nom différent !)
*/
if (!isset($_SESSION)) session_start(); 		// démarre la session
include('lib/lib.php'); 				// inclue fonctions génériques (ici: ouvreBase et afficheChamp)
$bdd = ouvreBase(); 					// ouvre la base de données ;
include('lib/ban-menu.php'); 				// affiche entête Html, bannière personnalisée et menu dynamique
// contrôle accès autorisé par les profils Aministrateur et Gestionnaire
autorise(array(5,9));
initBase($bdd);						// récup $IdRacGen, $IdRacObj et $IdRacRel
							// initialise également $maxselect (nombre de choix)
							
DEFINE ('s1ficheExiste','Erreur ! Fiche :'.$_POST['texte0'].' existe déjà ! (Modification interdite ici)');							
DEFINE ('s1ficheNomFiche','Erreur ! Le nom de la fiche doit commencer par Fiche suivi d\'un espace');							
DEFINE ('s1ficheRepet','Erreur ! Répétition doit être un nombre positif. Rien n\'a été enregistré !');
DEFINE ('s1ficheOK','Fiche: '.$_POST['texte0'].  ' bien enregistrée; suivante ?');
DEFINE ('s1ficheKO','Erreur ! Rien n\'a été enregistré !');
DEFINE ('s1ficheTitre','<h4>Création nouveau type de fiche</h4>');
DEFINE ('s1ficheGuide','<p>Saisir le nom de fiche souhaité; lui associer de 1 à '.$maxselect.' types d\'objet ou de fiches par sélection des options proposées. Pour chaque objet/fiche retenu fixer la répétition maxi utile. Par exemple fixer répétition à 3 pour afficher 3 prénoms ou encore fixer répétition à 2 pour afficher 2 fiches/blocs adresse.<br>Laisser à "Choix non retenu", les types d\'objet/fiches inutiles.<br/><b>Important: définir d\'abord les objets et ensuite la ou les sous fiches utiles. </b><br>Enfin appuyer sur le bouton Créer type de  fiche.<br/><i>Information: un type d\'objet ou de fiche est un objet/fiche générique invisible en recherche de données utilisateur.</i></p>');
DEFINE ('s1ficheFiche','Nom Fiche&nbsp;&nbsp; ');
DEFINE ('s1ficheObjet','Objet/Fiche ');
DEFINE ('s1objetRepetition','&nbsp; Répétition ');
DEFINE ('s1ficheNchoix','Choix non retenu');

// si Submit effectué et 1er champ du formulaire renseigné
// -------------------------------------------------------
if (isset($_POST['valid']) AND isset($_POST['texte0']) AND $_POST['texte0'] != NULL ) {	
 $poubelle = array_pop($_POST); 			// éliminer le post du valid
 $poubelle = array_pop($_POST); 			// éliminer le post du message
// vérifie unicité du nom de cette fiche générique
 $cle = existObjetInvisible($bdd,$IdRacFic,$_POST['texte0']);		// existe déjà sous le même nom ?
 if ($cle != 0) {
  $_POST['message'] = s1ficheExiste;
 }
 elseif (substr($_POST['texte0'],0,6) != "Fiche ") {
  $_POST['message'] = s1ficheNomFiche;
 }
 else {
  try {								// début essai traitement
   $bdd->beginTransaction(); 					// ouvre une transaction
// crée nouvelle fiche générique invisible et note son Id; 
   $idfiche = insertObjet($bdd,$IdRacFic,$_POST['texte0'],0);
// crée occ. objet_type pour cette fiche (type fiche important pour démarquer fiche de objet)
// $lgnomfiche globale initialisée dans initBase
   insertObjetType($bdd,$idfiche,1,1,$lgnomfiche,'fiche');
// pour chaque objet ou sous fiche générique choisi(e), crée son lien avec la fiche générique dans relation
   $ok = TRUE;
// $maxselect initialisé dans initBase
   for ($i=1;$i<$maxselect;$i++) {  
    if (isset($_POST['texte'.$i]) AND $_POST['texte'.$i] !="") {	// si id objet/sous fiche renseigné
     if (isset($_POST['repet'.$i]) AND is_numeric($_POST['repet'.$i]) AND intval($_POST['repet'.$i]) > 0 ) {
      insertRelation($bdd,$idfiche,intval($_POST['texte'.$i]),intval($_POST['repet'.$i]));	// crée occ. relation
     }
     else {
      $ok = FALSE;
      $_POST['message'] = s1ficheRepet;
     }
    }
   }
   if ($ok) { 
    $bdd->commit(); 						// valide et termine la transaction  
    $_POST['message'] = s1ficheOK;// informe l'utilisateur
   }
   else
    $bdd->rollback();
  }
  catch(Exception $e) {						// si incident durant l'essai
   $bdd->rollback();						// invalide la transaction
   $_POST['message'] = s1ficheKO;	// informe l'utilisateur
  }
 } 								// fin essai traitement
}

// affiche ou ré-affiche le formulaire de saisie
 echo '<form method="POST" action="s1fiche.php">';
 echo s1ficheTitre;
 echo s1ficheGuide;
/* affiche champs de saisie selon description de l'objet
 Id		généré par la base de données
 Id_Pere	= $IdRacFic
 */
 echo '<table><tr>';
 afficheRangTable(s1ficheFiche,'texte0','text','80','Fiche ','','');
 echo '</tr></table>';
// selection de tous les objets possibles
 $typeobjets = selectObjet($bdd,$IdRacObj,'%',0);// recherche des types d'objet 
 $options[0][0] = '';				// ajoute d'abord choix non retenu
 $options[0][1] = s1ficheNchoix;
 $nbtypeo = count($typeobjets);
 for ($t=0;$t<$nbtypeo;$t++) {			// puis tous les types d'objets
  $to = $t+1;
  $options[$to][0] = $typeobjets[$t][0];
  $options[$to][1] = $typeobjets[$t][1];
 }  
// selection des (sous) fiches possibles
$typefiches = selectObjet($bdd,$IdRacFic,'%',0);
$nbtypef = count($typefiches);
for ($t=0;$t<$nbtypef;$t++) {			// puis tous les types de fiches
  $to = $t+$nbtypeo+1;
  $options[$to][0] = $typefiches[$t][0];
  $options[$to][1] = $typefiches[$t][1];
 }
 echo '<table>';
 for ($i=1;$i<=$maxselect;$i++) {			// affiche les imax choix d'objets
  echo '<tr>';
  afficheRangTable(s1ficheObjet.$i,'texte'.$i,'select','10',$options,' ','');
  afficheRangTable(s1objetRepetition,'repet'.$i,'text','3','','','');
  echo '</tr>';
 }
 echo '</table>';
// affiche ligne message et bouton de soumission
 if (isset($_POST['message']))
  afficheChamp('','message','text','100',$_POST['message'],'','Readonly');
 else
  afficheChamp('','message','text','100','','','Readonly');
 echo '<hr><input type="submit" name="valid" value="Créer type de fiche" />';
?>
<script>
 document.getElementById('texte0').focus();
</script>
<?php
 echo '</form>';

/* affiche pied de page */
include('lib/pied.php');
?>
